<?php

namespace App\Entities;

use CodeIgniter\Entity\Entity;

abstract class CommonEntity extends Entity
{
    const DEFAULT_STATUS    = "";
    protected $datamap = [];
    protected $dates   = ['created_at', 'updated_at', 'deleted_at'];
    //사용법   : $client->created_at->format('Y-m-d') 
    //비교방법 : if ($client->created_at < new \DateTime('2024-01-01')) {
    protected $casts   = [];
    public function __construct(array|null $data = null)
    {
        parent::__construct($data);
    }

    public function getPK(): int|string
    {
        $field = constant("static::PK");
        return $this->attributes[$field] ?? "";
    }
    public function getTitle(): string
    {
        $field = constant("static::TITLE");
        return $this->attributes[$field] ?? "";
    }
    public function getCustomTitle(mixed $title = null): string
    {
        return  $title ? $title : $this->getTitle();
    }
    public function getStatus(): string
    {
        return $this->attributes['status'] ?? "";
    }
    final public function getUpdatedAt(): string
    {
        return $this->attributes['updated_at'] ?? "";
    }
    final public function getCreatedAt(): string
    {
        return $this->attributes['created_at'] ?? "";
    }
    final public function getDeletedAt(): string
    {
        return $this->attributes['deleted_at'] ?? "";
    }
}
